function varargout = command_edit(varargin)
% COMMAND_EDIT MATLAB code for command_edit.fig
%      COMMAND_EDIT, by itself, creates a new COMMAND_EDIT or raises the existing
%      singleton*.
%
%      H = COMMAND_EDIT returns the handle to a new COMMAND_EDIT or the handle to
%      the existing singleton*.
%
%      COMMAND_EDIT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in COMMAND_EDIT.M with the given input arguments.
%
%      COMMAND_EDIT('Property','Value',...) creates a new COMMAND_EDIT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before command_edit_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to command_edit_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% lbContext the above text to modify the response to help command_edit

% Last Modified by GUIDE v2.5 08-Jun-2011 13:15:23

% Begin initialization code - DO NOT LBCONTEXT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @command_edit_OpeningFcn, ...
                   'gui_OutputFcn',  @command_edit_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT LBCONTEXT


% --- Executes just before command_edit is made visible.
function command_edit_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to command_edit (see VARARGIN)

% Choose default command line output for command_edit
handles.output = hObject;

if(isempty(varargin) == 0)
    handles.execHandles = varargin{1};
end
execHandles = guidata(handles.execHandles);
%handles.mainHandles = mainHandles;

if(isempty(get(execHandles.listbox1, 'String')) == 0) % The listbox is not empty
    option = get(execHandles.listbox1, 'Value'); % Which item (command) is selected
    option = option(1);
    lbString = get(execHandles.listbox1, 'String'); % The whole cell array of commands

    if(ischar(lbString))
        set(handles.edit3, 'String', lbString);
    else
        editString = lbString(option);
        set(handles.edit3, 'String', editString{1});
    end
    %set(handles.edit3, 'String', get(mainHandles.edit15, 'String'));
end
%set(handles.listbox1, 'String', get(mainHandles.listbox6, 'String'));

set(handles.figure1, 'Name', 'Command editor');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes command_edit wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = command_edit_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton2.
% Cancel
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close 'Command editor';

% --- Executes on button press in pushbutton3.
% Ok
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

execHandles = guidata(handles.execHandles);
editString = get(handles.edit3, 'String');

% As long as this gui window is modal, the stuff from sm_command can be
% assumed to be unchanged and sm_commands listbox1's properties can be
% accessed here

%lbString_cell = cellstr(lbString)

if(isempty(get(execHandles.listbox1, 'String')) == 0) % The listbox is not empty
    lbString = get(execHandles.listbox1, 'String');
    option = get(execHandles.listbox1, 'Value');
    option = option(1);
    if(ischar(lbString))
        lbString = editString;
    else
        lbString{option} = editString;
    end
else
    lbString = editString;
    option(1) = 1;
end

set(execHandles.listbox1, 'String', lbString);
set(execHandles.listbox1, 'Value', option(1));

if(isempty(lbString) == 0)
    set(execHandles.pushbutton3, 'Enable', 'on');
    set(execHandles.checkbox1, 'Enable', 'on');
end

close 'Command editor';
    

function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: lbContext controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guiPosition = get(handles.figure1, 'position');
guiX = guiPosition(1);
guiY = guiPosition(2);
guiWidth = guiPosition(3);
guiHeight = guiPosition(4);

% Text edit:
lbWidth = guiWidth - 18;
lbPosition = get(handles.edit3, 'Position');
lbHeight = lbPosition(4);
lbX = lbPosition(1);
lbY = lbPosition(2);

set(handles.edit3, 'Position', [lbX lbY lbWidth lbHeight]);

% Min size 578x77:
if(guiWidth < 578)
   guiWidth = 578;
end
if(guiHeight < 77)
    guiHeight = 77;
end

%set(handles.figure1, 'Position', [])

% Buttons:

savePosition = get(handles.pushbutton3, 'Position');
cancelPosition = get(handles.pushbutton2, 'Position');
saveX = guiWidth - 166;
saveY = savePosition(2);
saveWidth = savePosition(3);
saveHeight = savePosition(4);
cancelX = guiWidth - 81;
cancelY = cancelPosition(2);
cancelWidth = cancelPosition(3);
cancelHeight = cancelPosition(4);

set(handles.pushbutton3, 'Position', [saveX saveY saveWidth saveHeight]);
set(handles.pushbutton2, 'Position', [cancelX cancelY cancelWidth cancelHeight]);
